# UndoCommand.py -- Pamhyr
# Copyright (C) 2023-2025  INRAE
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# -*- coding: utf-8 -*-

from copy import deepcopy
from tools import trace, timer

from PyQt5.QtWidgets import (
    QMessageBox, QUndoCommand, QUndoStack,
)

from Model.InitialConditionsAdisTS.InitialConditionsAdisTS \
    import InitialConditionsAdisTS
from Model.InitialConditionsAdisTS.InitialConditionsAdisTSList \
    import InitialConditionsAdisTSList

from Model.River import RiverReach


class SetCommand(QUndoCommand):
    def __init__(self, data, row, column, new_value):
        QUndoCommand.__init__(self)

        self._data = data
        self._row = row
        self._column = column

        if self._column == "name":
            self._old = self._data[self._row].name
        elif self._column == "value":
            self._old = self._data[self._row].value
        elif self._column == "concentration":
            self._old = self._data[self._row].concentration
        elif self._column == "eg":
            self._old = self._data[self._row].eg
        elif self._column == "em":
            self._old = self._data[self._row].em
        elif self._column == "ed":
            self._old = self._data[self._row].ed

        _type = float
        if column == "name":
            _type = str

        self._new = _type(new_value)

    def undo(self):
        if self._column == "name":
            self._data[self._row].name = self._old
        elif self._column == "value":
            self._data[self._row].value = self._old
        elif self._column == "concentration":
            self._data[self._row].concentration = self._old
        elif self._column == "eg":
            self._data[self._row].eg = self._old
        elif self._column == "em":
            self._data[self._row].em = self._old
        elif self._column == "ed":
            self._data[self._row].ed = self._old

    def redo(self):
        if self._column == "name":
            self._data[self._row].name = self._new
        elif self._column == "value":
            self._data[self._row].value = self._new
        elif self._column == "concentration":
            self._data[self._row].concentration = self._new
        elif self._column == "eg":
            self._data[self._row].eg = self._new
        elif self._column == "em":
            self._data[self._row].em = self._new
        elif self._column == "ed":
            self._data[self._row].ed = self._new


class SetBeginCommand(QUndoCommand):
    def __init__(self, wps, index, new_value):
        QUndoCommand.__init__(self)

        self._wps = wps
        self._index = index
        self._old = self._wps.get(self._index).begin_section
        self._new = new_value

    def undo(self):
        self._wps.get(self._index).begin_section = self._old

    def redo(self):
        self._wps.get(self._index).begin_section = self._new


class SetEndCommand(QUndoCommand):
    def __init__(self, wps, index, new_value):
        QUndoCommand.__init__(self)

        self._wps = wps
        self._index = index
        self._old = self._wps.get(self._index).end_section
        self._new = new_value

    def undo(self):
        self._wps.get(self._index).end_section = self._old

    def redo(self):
        self._wps.get(self._index).end_section = self._new


class SetEdgeCommand(QUndoCommand):
    def __init__(self, wps, index, edge):
        QUndoCommand.__init__(self)

        self._wps = wps
        self._index = index
        self._old = self._wps.get(self._index).reach
        self._new = edge

    def undo(self):
        self._wps.get(self._index).reach = self._old

    def redo(self):
        self._wps.get(self._index).reach = self._new


class AddCommand(QUndoCommand):
    def __init__(self, data, type, wps_spec, index):
        QUndoCommand.__init__(self)

        self._data = data
        self._type = type
        self._wps_spec = wps_spec
        self._index = index
        self._new = None

    def undo(self):
        self._data.delete_i([self._index])

    def redo(self):
        if self._new is None:
            self._new = self._data.new(self._index, self._type)
        else:
            self._data.insert(self._index, self._new)


class DelCommand(QUndoCommand):
    def __init__(self, wps, rows):
        QUndoCommand.__init__(self)

        self._wps = wps
        self._rows = rows

        self._wp = []
        for row in rows:
            self._wp.append(self._wps.get(row))

    def undo(self):
        for el in self._wp:
            el.set_as_not_deleted()

    def redo(self):
        for el in self._wp:
            el.set_as_deleted()
